// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__BD235B4F_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_)
#define AFX_MAINFRM_H__BD235B4F_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PartBrowser.h"
#include "GMEBrowser.h"
#include "GMEObjectInspector.h"
#include "GMEConsole.h"
#include "GMESearch.h"
#include "PanningWindow.h"
#include "GMEOLEApp.h"
// #include "..\include\stl\string"
//#include <string>


// Tooltip helper for components
class CComponentBar : public CToolBar {
	DECLARE_DYNCREATE(CComponentBar)
	afx_msg BOOL OnTT(UINT, NMHDR * pNMHDR, LRESULT * );
	DECLARE_MESSAGE_MAP()
};

class CMainFrame : public CMDIFrameWnd
{
	friend void CGMEApp::UpdateComponentLists(bool restart_addons);
	friend class CGMEOLEApp;
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
	static CMainFrame *theInstance;

	int timePaneNo;
	int paradigmPaneNo;
	int modePaneNo;
	int zoomPaneNo;

// Operations
public:
	void ActivateView(CView *view);
	void CreateNewView(CView *view = 0);
	void DestroyView(CView *view);
	void WriteStatusZoom(int zoomPct);
	void WriteStatusParadigm(const char *txt);
	void WriteStatusMode(const char *txt);
	void WriteStatusText(int pane,const char *txt);
	void UpdateTitle(LPCTSTR title);
	void SetPartBrowser(CGuiMetaModel *meta)		{ m_partBrowser.SetMetaModel(meta); }
	void SetPartBrowserBg(COLORREF bgColor)			{ m_partBrowser.SetBgColor(bgColor); m_partBrowser.PostMessage(WM_PAINT);}
	void ResetPartBrowser()							{ m_partBrowser.PostMessage(WM_PAINT); }
	void ChangePartBrowserAspect(int ind)			{ m_partBrowser.ChangeAspect(ind); }
	void CyclePartBrowserAspect()                   { m_partBrowser.CycleAspect(); }
	BOOL CMainFrame::VerifyBarState(LPCTSTR lpszProfileName);
    void ShowObjectInspector();
	void ShowFindDlg();
	void HideFindDlg();

	void StartAutosaveTimer(int secs);
	void StopAutosaveTimer();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_nTimePaneNo;
	virtual ~CMainFrame();

	void setGmeOleApp( CGMEOLEApp * the_ole_app);
	void setMgaProj();
	void clearGmeOleApp();
	void clearMgaProj();
	CGMEOLEApp *       mGmeOleApp;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	CPanningWindow	m_pannWin;
	CGMEConsole	m_console;


protected:  // control bar embedded members
	CStatusBar		m_wndStatusBar;
	CToolBar		m_wndToolBarMain;
	CToolBar		m_wndToolBarWins;
	CComponentBar	m_wndComponentBar;
	CDialogBar		m_wndDlgBar;
	CPartBrowser	m_partBrowser;
	CGMEBrowser	    m_browser;
	CGMEObjectInspector	m_objectInspector;
	CGMESearch		m_search;

	UINT			m_autosaveTimerID;

// Generated message map functions
protected:
	afx_msg void OnUpdateTime(CCmdUI* pCmdUI);
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewPartbrowser();
	afx_msg void OnViewPannWin();
	afx_msg void OnUpdateViewPannWin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPartbrowser(CCmdUI* pCmdUI);
	afx_msg void OnViewBrowser();
	afx_msg void OnUpdateViewBrowser(CCmdUI* pCmdUI);
	afx_msg void OnViewAttributes();
	afx_msg void OnUpdateViewAttributes(CCmdUI* pCmdUI);
	afx_msg void OnEditSearch();
	afx_msg void OnUpdateEditSearch(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnViewConsole();
	afx_msg void OnUpdateViewConsole(CCmdUI* pCmdUI);
	afx_msg void OnViewRefreshSourcecontrol();
	afx_msg void OnUpdateViewRefreshSourcecontrol(CCmdUI* pCmdUI);
	afx_msg void CMainFrame::OnClose();
	afx_msg void OnDropFiles(HDROP);

	afx_msg void OnBtnBack();
	afx_msg void OnBtnHome();
	afx_msg void OnUpdateBtnBack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBtnHome(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL InitStatusBar(UINT *pIndicators, int nSize, int nSeconds);
//	IMgaObject*	modelFindByPath(IMgaModel *model,  const wstring& strPath);
//	IMgaObject*	folderFindByPath(IMgaFolder* folder, const wstring& strPath);

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__BD235B4F_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_)
